//------------------------------------------------------------------------------
// 
//	ACTvZT[rX TvvO
//	INIt@CNX
//
//	Copyrights (c) 2004-2009 Advanced Core Technologies, Inc. All rights reserved.
//
//	2005/03/04 Rev.1.00 RIN J
//
//------------------------------------------------------------------------------

//	Using Namespace
using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Text;

namespace SampleMX
{
	/// <summary>
	/// IniFile ̊Tv̐łB
	/// </summary>
	/// 
	//	Definition of Class
	public class IniFile
	{
		//------------------------------------------------------------------------------
		//	Win32 API
		//------------------------------------------------------------------------------

		//	[Private]

		//	GetPrivateProfileString
		[DllImport("kernel32.dll", EntryPoint="GetPrivateProfileString", CharSet=CharSet.Auto)]
		private static extern Int32 GetPrivateProfileString(String lpszSectionName, String lpszKeyName,
			String lpszDefault, StringBuilder lpszReturnedString, Int32 nSize, String lpszFileName);
		//	GetPrivateProfileInt
		[DllImport("kernel32.dll", EntryPoint="GetPrivateProfileInt", CharSet=CharSet.Auto)]
		private static extern Int32 GetPrivateProfileInt(String lpszSectionName, String lpszKeyName,
			Int32 nDefault, String lpszFileName);
		//	WritePrivateProfileString
		[DllImport("kernel32.dll", EntryPoint="WritePrivateProfileString", CharSet=CharSet.Auto)]
		private static extern Int32 WritePrivateProfileString(String lpszSectionName, String lpszKeyName,
			String lpszString, String lpszFileName);

		//------------------------------------------------------------------------------
		//	Constants
		//------------------------------------------------------------------------------

		//	[Private]

		private const String DIRECTORY_SEPARATOR = "\\";	//	fBNgԂ̋؂L
		private const String EXTENTION_SIGNATURE = ".";		//	gq̎ʕ
		private const String EXTENTION_INIFILE = ".ini";	//	INIt@C̊gq
		private const Int32 BUFFER_LENGTH_MAX = 260 + 1;	//	obt@񒷂̍ől

		//------------------------------------------------------------------------------
		//	Members
		//------------------------------------------------------------------------------

		//	[Private]

		private static String m_AppPath;					//	AvP[VtH_pX
		private static String m_FileName;					//	INIt@C

		//------------------------------------------------------------------------------
		//	Methods
		//------------------------------------------------------------------------------

		//	ÓIRXgN^
		static IniFile()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
			FileInfo AppFileInfo;		//	t@CNX
			String lpszFileNameBuffer;	//	INIt@C쐬Ɏgpobt@
			Int32 nExtentionIndex;		//	gq INDEX l

			//	CX^X̍쐬
			AppFileInfo = new FileInfo(System.Reflection.Assembly.GetExecutingAssembly().Location);

			//	AvP[VtH_̃pXݒ肷
			m_AppPath = AppFileInfo.DirectoryName;

			//	ftHgINIt@Cݒ肷
			lpszFileNameBuffer = AppFileInfo.FullName.Substring(m_AppPath.Length + 1);	//	st@C̎擾

			//	gq̒T
			nExtentionIndex = lpszFileNameBuffer.LastIndexOf(EXTENTION_SIGNATURE);
			//	gq݂͑邩H
			if (nExtentionIndex != -1) {
				//	݂̊gq̍폜
				lpszFileNameBuffer = lpszFileNameBuffer.Remove(nExtentionIndex, lpszFileNameBuffer.Length - nExtentionIndex);
			}
			//	INIt@Cݒ肷
			m_FileName = String.Concat(lpszFileNameBuffer, EXTENTION_INIFILE);			//	gq𖖔ɕt
		}

		//	[Public]

		//	INIt@C̎w肵ZNṼL[當擾
		//	p[^
		//		lpszSectionName	[IN]ZNV
		//		lpszKeyName		[IN]L[
		//		lpszDefault		[IN]INIt@C݂ȂꍇɕԂl
		//	߂l
		//		w肵L[̕(Ggꍇ)
		//		lpszDefault			(GgȂꍇ)
		//		̕			(lpszDefault  null w肳Ăꍇ)
		public static String GetProfileString(String lpszSectionName, String lpszKeyName, String lpszDefault)
		{
			StringBuilder lpszReturnedString;
			
			lpszReturnedString = new StringBuilder(BUFFER_LENGTH_MAX);

			//	ftHglw肳Ă邩H
			if (lpszDefault != null) {
				GetPrivateProfileString(lpszSectionName, lpszKeyName, lpszDefault, lpszReturnedString, 
					lpszReturnedString.Capacity, m_AppPath + DIRECTORY_SEPARATOR + m_FileName);
			} else {
				GetPrivateProfileString(lpszSectionName, lpszKeyName, "", lpszReturnedString, 
					lpszReturnedString.Capacity, m_AppPath + DIRECTORY_SEPARATOR + m_FileName);
			}

			return lpszReturnedString.ToString();
		}

		//	INIt@C̎w肵ZNṼL[琔l擾
		//	p[^
		//		lpszSectionName	[IN]ZNV
		//		lpszKeyName		[IN]L[
		//		lpszDefault		[IN]INIt@C݂ȂꍇɕԂl
		//	߂l
		//		w肵L[̐l	(Ggꍇ)
		//		nDefault			(GgȂꍇ)
		//		0					(GgɑΉlłȂꍇ)
		public static Int32 GetProfileInt(String lpszSectionName, String lpszKeyName, Int32 nDefault)
		{
			return GetPrivateProfileInt(lpszSectionName, lpszKeyName, nDefault, 
				m_AppPath + DIRECTORY_SEPARATOR + m_FileName);
		}

		//	INIt@C̎w肵ZNṼL[ɕݒ肷
		//	p[^
		//		lpszSectionName	[IN]ZNV
		//		lpszKeyName		[IN]L[
		//		lpszString		[IN]ݒ肷镶
		//	߂l
		//		0ȊO	̐ݒɐ
		//		0		̐ݒɎs
		public static Int32 WriteProfileString(String lpszSectionName, String lpszKeyName, String lpszString)
		{
			return WritePrivateProfileString(lpszSectionName, lpszKeyName, lpszString, 
				m_AppPath + DIRECTORY_SEPARATOR + m_FileName);
		}

		//	INIt@C̎w肵ZNṼL[ɐlݒ肷
		//	p[^
		//		lpszSectionName	[IN]ZNV
		//		lpszKeyName		[IN]L[
		//		nValue			[IN]ݒ肷鐔l
		//	߂l
		//		0ȊO	l̐ݒɐ
		//		0		l̐ݒɎs
		public static Int32 WriteProfileInt(String lpszSectionName, String lpszKeyName, Int32 nValue)
		{
			return WritePrivateProfileString(lpszSectionName, lpszKeyName, nValue.ToString(), 
				m_AppPath + DIRECTORY_SEPARATOR + m_FileName);
		}

		//	INIt@Cݒ(ύX)
		//	p[^
		//		lpszFileName	[IN]INIt@C
		//	߂l
		//		Ȃ
		public static void SetFileName(String lpszFileName)
		{
			m_FileName = lpszFileName;
		}

		//	AvP[VtH_pXݒ(ύX)
		//	p[^
		//		lpszAppPath	[IN]AvP[VtH_pX
		//	߂l
		//		Ȃ
		public static void SetAppPath(String lpszAppPath)
		{
			m_AppPath = lpszAppPath;
		}
	}
}

//	End of Source
